﻿@using LAP.DomainModels.Entities.Admin;
@using System.Reflection;
@model IEnumerable<ClientActivityLog>
@{
    ViewData["Title"] = "Activity Log";
    string[] names = ViewBag.Names;
    var clientName = names[0];
    var spouseName = names[1];
    var fieldMapping = MenuDataHelper.GeFieldMappingDataAsync();
    int TimeZone = ViewBag.TimeZone;
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="card-header flex-wrap border-0 p-0">
                <div class="card-title mb-0">
                    <div class="d-flex justify-content-between">
                        <div>
                            <h3 class="card-label text-primary">
                                Activity Log
                            </h3>
                        </div>
                    </div>
                </div>
                <div class="card-body pt-4">
                    @if (Model.Count() > 0)
                    {
                        <div class="timeline activity-log timeline-5">
                            @foreach (var item in Model)
                            {
                                var actionText = item.ActionType == ActionEnum.Insert.ToString() ? "added a new" :
                                item.ActionType == ActionEnum.Update.ToString() ? "updated the" : "deleted the";
                                var createdByEmail = item.CreatedByUserId > 0 ? item.CreatedByUser.Username : item.Owner.Username;
                                var createdByName = item.CreatedByUserId > 0 ? item.CreatedByUser.UserData.Name : item.Owner.ClientData.Name;
                                var colorClass = (item.ActionType == ActionEnum.Insert.ToString() ? "success" : item.ActionType == ActionEnum.Update.ToString() ? "warning" : "danger");
                                <div class="timeline-item align-items-start mb-0">
                                    <div class="timeline-label font-weight-bold">@item.TimeStamp.AddMinutes(-TimeZone).ToString("MMM dd, yyyy hh:mm tt")</div>
                                    <div class="timeline-badge">
                                        <i class="fa fa-genderless text-@colorClass icon-xl"></i>
                                    </div>
                                    <div class="timeline-content pl-3">
                                        <span class="font-weight-bolder text-maroon" role="button" data-toggle="tooltip" data-original-title="@createdByEmail">@createdByName</span>
                                        @actionText
                                        @item.EntityModuleName
                                        <span class="text-primary">@Html.Raw(item.Title)</span>
                                        @if (item.ActionType != ActionEnum.Delete.ToString() && item.Changes != null)
                                        {
                                            <div class="alert alert-custom alert-notice alert-light-@colorClass mt-2" role="alert" style="width:fit-content">
                                                <ul class="mb-0">
                                                    @foreach (var item2 in item.Changes)
                                                    {
                                                        var fieldChange = (FieldChangeModel)item2.Value;
                                                        var fieldMaps = fieldMapping.Where(m => m.FieldName == item2.Key);
                                                        var fieldMap = fieldMaps.Count() > 1 ? fieldMaps.FirstOrDefault(m => m.TableName == item.EntityName) : fieldMaps.FirstOrDefault();
                                                        var fieldTitle = fieldMap != null ? fieldMap.Title : item2.Key;
                                                        fieldTitle = fieldTitle.Replace("{clientName}", clientName).Replace("{spouseName}", spouseName);

                                                        var oldValueFormatted = fieldTitle.Contains("Version") ? fieldChange.OldValueFormatted == "Yes" ? "InDepth" : "Express" : fieldChange.OldValueFormatted;
                                                        var newValueFormatted = fieldTitle.Contains("Version") ? fieldChange.NewValueFormatted == "Yes" ? "InDepth" : "Express" : fieldChange.NewValueFormatted;

                                                        oldValueFormatted = !string.IsNullOrEmpty(fieldChange.OldValueFormatted) && fieldChange.OldValueFormatted.Contains("{") ? fieldChange.OldValueFormatted.Replace("{clientName}", clientName).Replace("{spouseName}", spouseName) : oldValueFormatted;
                                                        newValueFormatted = !string.IsNullOrEmpty(fieldChange.NewValueFormatted) && fieldChange.NewValueFormatted.Contains("{") ? fieldChange.NewValueFormatted.Replace("{clientName}", clientName).Replace("{spouseName}", spouseName) : newValueFormatted;
                                                        @if (item.ActionType == ActionEnum.Insert.ToString())
                                                        {
                                                            if (fieldChange.OldValue != null && fieldChange.NewValue != null && !string.IsNullOrEmpty(newValueFormatted) && item2.Key != "Id")
                                                            {
                                                                <li class="font-weight-bolder">@fieldTitle: <span class="font-weight-normal">@Html.Raw(newValueFormatted)</span></li>
                                                            }
                                                        }
                                                        else
                                                        {
                                                            if (oldValueFormatted != newValueFormatted)
                                                            {
                                                                <li>
                                                                    <span class="font-weight-bolder">@fieldTitle</span>
                                                                    <span class="font-weight-normal" style="text-underline-position: under">
                                                                        @if (!string.IsNullOrEmpty(oldValueFormatted) && !string.IsNullOrEmpty(newValueFormatted))
                                                                        {
                                                                            <span>
                                                                                updated from
                                                                                <u>@Html.Raw(oldValueFormatted)</u>
                                                                                to
                                                                                <u>@Html.Raw(newValueFormatted)</u>
                                                                            </span>

                                                                        }
                                                                        else
                                                                        {
                                                                            <span>
                                                                                @(
                                                                                    !string.IsNullOrEmpty(oldValueFormatted) ? "reset from" : "updated to"
                                                                                    )
                                                                                <u>
                                                                                    @(
                                                                                        !string.IsNullOrEmpty(oldValueFormatted) ? Html.Raw(oldValueFormatted) : @Html.Raw(newValueFormatted)
                                                                                        )
                                                                                </u>
                                                                            </span>
                                                                        }
                                                                    </span>
                                                                </li>
                                                            }
                                                        }
                                                    }
                                                </ul>
                                            </div>
                                        }
                                        @if (item.EntityId == null)
                                        {
                                            <a href="javascript:;" class="btn-view-detail" data-parentid="@item.Id" data-client-guid="@item.Owner.Guid">View Detail</a>
                                        }
                                    </div>
                                </div>
                            }
                        </div>
                    }
                    else
                    {
                        <div class="alert alert-secondary" role="alert">No Activity Logged!</div>
                    }
                </div>
            </div>
        </div>
    </div>
</div>
<div class="modal" id="ActivityLogChildrenModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
@section scripts{
    <script>
        $(document).on("click", ".btn-view-detail", function () {
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var parentid = $(this).attr("data-parentid");
            var clientguid = $(this).attr("data-client-guid");
            loadPartialView(`home/getactivitylogchildren?parentid=${parentid}&guid=${clientguid}`, "ActivityLogChildrenModal");
            setTimeout(function () { KTApp.unblockPage(); }, 1000);
            $("#ActivityLogChildrenModal").modal({ backdrop: 'static' });
        });
    </script>
}